﻿B4J=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=8.9
@EndOfDesignText@
Sub Class_Globals
	Public Vue As BANanoObject
	Public Vuetify As BANanoObject
	Private BANano As BANano
	Private methods As Map
	Private computed As Map
	Private watches As Map
	Private filters As Map
	Public mCallBack As Object   'ignore
	Private routes As List
	Private components As Map
	Private options As Map
	Public data As BANanoObject
	Public refs As BANanoObject
	Private store As BANanoObject
	Private state As Map
	Public Template As String
	Private VuetifyOptions As Map
	Private modules As Map
	Public Body As BANanoElement
	Public AppTemplate As BANanoElement
	Public VApp As BANanoElement
	Public VMain As BANanoElement
End Sub

'initialize the vue & vuetify workspace
Public Sub Initialize(Module As Object)
	mCallBack = Module
	methods.Initialize 
	computed.Initialize 
	watches.Initialize 
	filters.Initialize 
	routes.Initialize 
	components.Initialize 
	options.Initialize 
	VuetifyOptions.Initialize
	state.Initialize
	modules.Initialize
	data.Initialize5 
	
	'initiaze vue
	Vue.Initialize("Vue")
	'create an observable store
	store = Vue.RunMethod("observable", Array(state))
	Vue.GetField("prototype").SetField("$store", store)
	
	'get the already built in body
	Body = BANano.GetElement("#body")
	'add a template
	AppTemplate = AddElement(Body, "apptemplate", "v-template")
	'add the v-app
	VApp = AddElement(AppTemplate, "app", "v-app")
	'add v-main
	VMain = AddElement(VApp, "vmain", "v-main")
End Sub

'generic sub to add parent child items
Sub AddElement(parent As BANanoElement, elID As String, elTag As String) As BANanoElement	'ignoreDeadCode
	elID = elID.ToLowerCase
	Dim parentID As String = parent.name
	parentID = parentID.tolowercase
	'
	Dim pe As BANanoElement = GetElement($"#${parentID}"$)
	Dim ec As BANanoElement = pe.Append($"<${elTag} id="${elID}"></${elTag}>"$).Get($"#${elID}"$)
	Return ec
End Sub

'returns the element
Sub GetElement(elID As String) As BANanoElement			'ignoreDeadCode
	elID = elID.tolowercase
	elID = elID.Replace("#", "")
	Dim pe As BANanoElement = BANano.GetElement($"#${elID}"$)
	Return pe
End Sub

'serve the application on the web server
Sub Serve					'ignoreDeadCode
	'get the content in the template, we need the html
	Dim AppTemplate As BANanoElement = BANano.GetElement($"#apptemplate"$)
	'get the build html
	Template = AppTemplate.GetHTML
	'replace the v-template
	Template = Template.Replace("v-template", "template")
	
	'create a new Vuetify App
	Vuetify.Initialize2("Vuetify", VuetifyOptions)
	
	'set where we should render the app to
	options.Put("el", "#app")
	'options for vue
	options.Put("store", store)
	options.Put("vuetify", Vuetify)
	'return data for 
	Dim cb As BANanoObject = BANano.CallBack(Me, "returndata", Null)
	options.Put("data", cb.Result)
	options.Put("components", components)
	options.Put("methods", methods)
	options.Put("filters", filters)
	options.Put("computed", computed)
	options.Put("watch", watches)
	options.Put("template", Template)
	'create a new Vue App using options
	Vue.Initialize2("Vue", Array(options))
	'get references
	store = Vue.GetField("$store")
	data = Vue.GetField("$data")
	refs = Vue.GetField("$refs")
End Sub

'link events
Sub On(Module As Object, EL As BANanoElement, Event As String, args As String)		'ignoreDeadCode
	Event = Event.ToLowerCase
	Dim elID As String = EL.name
	elID = elID.tolowercase
	'
	Event = Event.Replace(":","")
	Event = Event.Replace(".","")
	Event = Event.Replace("-","")
	'define the event for gthe control
	Dim MethodName As String = $"${elID}_${Event}"$
	'the method does not exist on the module
	If SubExists(Module, MethodName) = False Then Return
	If BANano.IsUndefined(args) Or BANano.IsNull(args) Then args = ""
	Dim scode As String
	If args = "" Then
		scode = MethodName
	Else	
		scode = $"${MethodName}(${args})"$
	End If
	EL.SetAttr($"v-on:${Event}"$, scode)
	'arguments for the event
	'define a callback
	Dim e As BANanoEvent 'ignore
	Dim cb As BANanoObject = BANano.CallBack(Module, MethodName, Array(e))
	methods.Put(MethodName, cb)
End Sub

'define the data function
private Sub returndata As BANanoObject			'ignoredeadcode
	Return data
End Sub

'set the state
Sub SetData(k As String, v As Object)			'ignoreDeadCode
	data.setfield(k, v)
End Sub

'get the state
Sub GetData(k As String) As Object				'ignoreDeadCode
	Dim obj As Object = data.GetField(k).Result
	Return obj
End Sub

'generic sub to add html to an element
Sub AddHTML(parent As BANanoElement, html As String)			'ignoreDeadCode
	Dim parentID As String = parent.name
	parentID = parentID.tolowercase
	Dim pe As BANanoElement = BANano.GetElement($"#${parentID}"$)
	pe.Append(html)
End Sub